Attribute VB_Name = "Module"
Option Explicit



Global TAG_INFO(12) As String

Function GetTAGName(IDType$, IDnum%) As String
  
  If IDType = "ID1" Then
    Select Case IDnum%
      Case 1: GetTAGName = "Track:"
      Case 2: GetTAGName = "Title:"
      Case 3: GetTAGName = "Knstler:"
      Case 4: GetTAGName = "Album:"
      Case 5: GetTAGName = "Jahr:"
      Case 6: GetTAGName = "Kommentar:"
      Case 7: GetTAGName = "Genre:"
      Case Else: GetTAGName = "Unbekannt:"
    End Select
  ElseIf IDType = "ID2" Then
    Select Case IDnum%
       Case 1: GetTAGName = "Track:"
       Case 2: GetTAGName = "Titel:"
       Case 3: GetTAGName = "Knstler:"
       Case 4: GetTAGName = "Album:"
       Case 5: GetTAGName = "Genre:"
       Case 6: GetTAGName = "Jahr:"
       Case 7: GetTAGName = "Kommentar:"
       Case 8: GetTAGName = "Encoded by:"
       Case 9: GetTAGName = "Link:"
      Case 10: GetTAGName = "Copyright:"
      Case 11: GetTAGName = "org. Knstler:"
      Case 12: GetTAGName = "Composer:"
      Case Else: GetTAGName = "Unbekannt:"
    End Select
  Else
    GetTAGName = "Unbekannt:"
  End If
End Function


Function getID(FileName$) As Boolean
Dim ff%
Dim Strg$
Dim fn$
Dim i&

  fn$ = FileName$
  ff% = FreeFile
  Strg$ = String$(3, "!")
  
  For i& = 0 To 12
    TAG_INFO(i&) = ""
  Next i&
  
  Open fn$ For Binary As ff%
  Get ff%, LOF(ff%) - 127, Strg$
  
  
  If Strg$ <> "TAG" Then
     getID = False
     Close ff%
  Else
     Close ff%
     getID = getID1(fn$)
  End If
End Function
'
'=======================================================================
'======================            IDV2        =========================
'=======================================================================
'

Function getID2(MP3FileName$) As Boolean
Dim lngID3Length As Long
Dim ID3Length$, ID3Version%, ID3V2Tag$
Dim lngFrameLen
Dim FrameLen$, FrameName$, Frame%
Dim i&, ff%
Dim EStrg$, Char$, Strg$
  
    ff% = FreeFile
  
  Open MP3FileName$ For Binary As ff%
    
    'Versionkontrolle
    Strg$ = String$(1, "!")
    Get ff%, 4, Strg$
    ID3Version% = Asc(Strg$)
    
    If (ID3Version% <> 3) And (ID3Version% <> 4) Then
       'MsgBox "Unbekannte Version! (" & Str(ID3Version) & ")"
       getID2 = False
       Close ff%
       Exit Function
    End If
      
     
    'Lnge bestimmen
    Strg$ = String$(4, "!")
    Get ff%, 7, Strg$
    ID3Length$ = Strg$
  
  Close ff%
     
  
  'VB hat kein DWORD => Selbst basteln.
  lngID3Length = 8 * 8 * 256 * Asc(Mid$(ID3Length$, 1, 1)) + _
                     8 * 256 * Asc(Mid$(ID3Length$, 2, 1)) + _
                         256 * Asc(Mid$(ID3Length$, 3, 1)) + _
                               Asc(Mid$(ID3Length$, 4, 1))
      

    ff% = FreeFile
    ID3V2Tag$ = String$(lngID3Length + 10, "!")
    
    Open MP3FileName$ For Binary As ff%
      Get ff%, 1, ID3V2Tag$
    Close ff%

    
  ID3V2Tag$ = Mid$(ID3V2Tag$, 11) & "3DI"
      

          
      
  Do
   'Frame-Header auslesen
   FrameName$ = Left$(ID3V2Tag$, 4)
   FrameLen$ = Mid$(ID3V2Tag$, 5, 4)
   ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
        
   'Frame-Content bestimmen
   Select Case UCase(FrameName$)
     Case "TRCK": Frame% = 1  'Track
     Case "TIT2": Frame% = 2  'Titel
     Case "TPE1": Frame% = 3  'Knstler
     Case "TALB": Frame% = 4  'Album
     Case "TCON": Frame% = 5  'Genre
     Case "TYER": Frame% = 6  'Jahr
     Case "COMM": Frame% = 7  'Kommentar
     Case "TENC": Frame% = 8  'Encoder
     Case "WXXX": Frame% = 9  'Link
     Case "TCOP": Frame% = 10 'Copyright
     Case "TOPE": Frame% = 11 'Ursprnglicher Knstler
     Case "TCOM": Frame% = 12 'Composer
     Case Else:   Frame% = 0  'Fehler
   End Select
   
   If Frame% <> 0 Then
     lngFrameLen = 8 * 8 * 256 * Asc(Mid$(FrameLen$, 1, 1)) + _
                       8 * 256 * Asc(Mid$(FrameLen$, 2, 1)) + _
                           256 * Asc(Mid$(FrameLen$, 3, 1)) + _
                                 Asc(Mid$(FrameLen$, 4, 1))
     
     If (Left$(ID3V2Tag$, 1) = Chr$(0)) And (lngFrameLen > 0) Then
       EStrg$ = Mid$(ID3V2Tag$, 2, lngFrameLen - 1)
     Else
       EStrg$ = Left$(ID3V2Tag$, lngFrameLen)
     End If
     
     TAG_INFO(Frame%) = StripChr0(EStrg$)
   End If
   
   ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
  Loop Until Len(ID3V2Tag$) = 0
  
  TAG_INFO(0) = "ID2"
  getID2 = True
End Function

'
'=======================================================================
'======================            IDV1        =========================
'=======================================================================
'

Public Function getID1(MP3FileName$) As Boolean
Dim ff%
Dim Strg$
  ff% = FreeFile
  Open MP3FileName$ For Binary As ff%
    
    Strg$ = String$(3, "!")
    Get ff%, LOF(ff) - 127, Strg$
    
    Strg = String$(30, "!"): Get ff%, , Strg: TAG_INFO(2) = Trim(StripChr0(Strg))
    Strg = String$(30, "!"): Get ff%, , Strg: TAG_INFO(3) = Trim(StripChr0(Strg))
    Strg = String$(30, "!"): Get ff%, , Strg: TAG_INFO(4) = Trim(StripChr0(Strg))
    Strg = String$(4, "!"): Get ff%, , Strg: TAG_INFO(5) = Trim(StripChr0(Strg))
    Strg = String$(29, "!"): Get ff%, , Strg: TAG_INFO(6) = Trim(StripChr0(Strg))
    Strg = String$(1, "!"): Get ff%, , Strg: TAG_INFO(1) = Str(Asc(Strg))
    Strg = String$(1, "!"): Get ff%, , Strg: TAG_INFO(7) = Str(Asc(Strg))
  Close ff%
  
  TAG_INFO(0) = "ID1"
  getID1 = True
End Function

Function StripChr0(NAMEstr$) As String
Dim l&, s$, Nstr$
  
  Nstr$ = ""
  
  For l& = 1 To Len(NAMEstr)
    s$ = Mid$(NAMEstr$, l&, 1)
    If s$ = Chr(0) Then s$ = ""
    Nstr$ = Nstr$ & s$
  Next l&
  StripChr0 = Nstr$
End Function

Function StripInvalidChars(NAMEstr$) As String
Dim l&, s$, Nstr$
  
  Nstr$ = ""
  
  For l& = 1 To Len(NAMEstr)
    s$ = Mid$(NAMEstr$, l&, 1)
    If (s$ = "|") Or (s$ = "?") Or _
       (s$ = "<") Or (s$ = ">") Or _
       (s$ = "/") Or (s$ = "\") Or _
       (s$ = "*") Or (s$ = ":") Or _
       (s$ = Chr(34)) Or (Asc(s$) < 31) Then s$ = "_"
    Nstr$ = Nstr$ & s$
  Next l&
  StripInvalidChars = Nstr$
End Function


Function GetPATH(PATHstr$) As String
Dim l&
  
  For l& = Len(PATHstr) To 1 Step -1
    If Mid$(PATHstr$, l&, 1) = "\" Then
      GetPATH = Mid$(PATHstr$, 1, l&)
      Exit For
    End If
  Next l&
End Function

Function GetNAME(NAMEstr$) As String
Dim l&
  
  For l& = Len(NAMEstr) To 1 Step -1
    If Mid$(NAMEstr$, l&, 1) = "\" Then
      GetNAME = Mid$(NAMEstr$, l& + 1)
      Exit For
    End If
  Next l&
End Function

Sub DoIT(Strg$)
Dim fn$, nFn$
Dim FPath$
Dim A$, T$
Dim ff%
Dim fso As Object

  
  Set fso = CreateObject("Scripting.FileSystemObject")
  
  FPath$ = GetPATH(Strg$)
     fn$ = GetNAME(Strg$)
     ff% = FreeFile
      T$ = ""
      A$ = ""
  
  If getID(Strg$) Then
    If (TAG_INFO(0) = "ID1") Or (TAG_INFO(0) = "ID2") Then
    
      T$ = StripInvalidChars(Trim(TAG_INFO(2)))
      A$ = StripInvalidChars(Trim(TAG_INFO(3)))
      nFn$ = A$ & " - " & T$ & ".mp3"
      If (fn$ <> nFn$) And (fn$ <> " - ") Then
        nFn$ = CheckIfExistsAndRename(nFn$, FPath$)
        Name FPath$ & fn$ As FPath & nFn$
      End If
    Else
      If fso.FolderExists(FPath$ & "NO_TAG") = False Then MkDir FPath$ & "NO_TAG"
      fso.movefile FPath$ & fn$, FPath$ & "NO_TAG\" & fn$
    End If
  Else
    If fso.FolderExists(FPath$ & "NO_TAG") = False Then MkDir FPath$ & "NO_TAG"
    fso.movefile FPath$ & fn$, FPath$ & "NO_TAG\" & fn$
  End If
End Sub


Function CheckIfExistsAndRename(FileName$, FilePath$) As String
Dim fso As Object
Dim b As Boolean
Dim c&, sc$, n$
  
    
  c& = 1
  sc$ = ""
  Set fso = CreateObject("Scripting.FileSystemObject")
  
  If fso.FileExists(FilePath$ & FileName$) = False Then
    CheckIfExistsAndRename = FileName$
    Exit Function
  End If
  
  Do
  
  
    If c& < 10 Then
       sc$ = "(0" & CStr(c&) & ")"
    Else
       sc$ = "(" & CStr(c&) & ")"
    End If
    
    n$ = Mid$(FileName$, 1, Len(FileName$) - 4) & sc$ & Mid$(FileName$, Len(FileName) - 4)
        
    b = fso.FileExists(FilePath$ & n$)
    
    c& = c& + 1
  
  Loop Until b = False
  
  CheckIfExistsAndRename = n$
End Function

Function CheckIfFolderExists(Path2Folder$) As Boolean
Dim fso As Object
  Set fso = CreateObject("Scripting.FileSystemObject")
  
  If fso.FolderExists(Path2Folder$) Then
    CheckIfFolderExists = True
  Else
    CheckIfFolderExists = False
  End If
End Function

